
#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")
#endif

#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;
using namespace gui;

IrrlichtDevice *device;

class MyEventReceiver : public IEventReceiver
{
public:
	virtual bool OnEvent(const SEvent& event)
	{
		if(event.EventType == EET_KEY_INPUT_EVENT)
		{
			if(event.KeyInput.PressedDown)
			{
				switch(event.KeyInput.Key)
				{
					case KEY_ESCAPE:
						//foCXI܂
						device->closeDevice();
						return true;
					default:
						return false;
				}
			}
			return true;
		}
		return false;
	}
};

#ifdef WIN32
	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
#else
	int main()
#endif
{
	MyEventReceiver Receiver;

	device = createDevice(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,false,&Receiver);
	IVideoDriver *driver = device->getVideoDriver();
	ISceneManager* smgr  = device->getSceneManager();

	device->setEventReceiver(&Receiver);

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	//Cg
	smgr->addLightSceneNode(0, vector3df(5,0,-5), SColorf(0xFFFFFFFF), 100.0f);

	//Jݒ
	smgr->addCameraSceneNode(0, vector3df(0,0,-5), vector3df(0,0,0));

	//tHgݒ
	IGUIEnvironment *Env = device->getGUIEnvironment(); 
	IGUIFont* Font;
	Font = Env->getFont("font.bmp");


	while(device->run())
	{
		driver->beginScene(true,true,0xFF6060FF);

		Font->draw(L"PUSH ESC TO EXIT",rect<s32>(16,16,0,0),0xFFFFFFFF);    

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	driver->drop();

	return 0;
}
